import math

t = int(input())
tests = [map(int, input().split()) for _ in range(t)]

def gd(n: int) -> int:
    """Greatest divisor"""
    return next(div for div in range(int(math.sqrt(n)), 0, -1) if n % div == 0)

for a, b, k, m in tests:
    # If we need not even number of squares, it's automatically impossible
    if m % 2:
        print(-1)
        continue

    _gd = gd(m)
    cuts = (_gd - 1, m // (_gd) - 1)
    print(min(cuts), max(cuts))
    
