import sys

sys.setrecursionlimit(10 ** 6)

n, m = map(int, input().split())
A = list(map(int, input().split()))

if m != 2 or A[0] != 1:
    raise NotImplementedError

known = {}

base = {}
for k in range(A[1]):
    base[k] = 2 ** k

def f(n: int) -> int:
    if n in known:
        return known[n]

    if n in base:
        return base[n]
    
    res = f(n - 1) + f(n - A[1])
    known[n] = res
    return res

print(f(n))

