import itertools
import sys

sys.setrecursionlimit(10 ** 6)

n, m = map(int, input().split())
A = list(map(int, input().split()))

if m != 2 or A[0] != 1:
    raise NotImplementedError

known = {}


def smart(n: int, k: int) -> int:
    if n in known:
        return known[n]

    if n < k:
        return 2 ** n
    
    res = smart(n - 1, k) + smart(n - k, k)
    known[n] = res
    return res % (10 ** 9 + 7)


# def dumb(k, n):
#     mapping = {}
#     for seq in itertools.product([1, k], repeat=n):
#         known = []
#         b = []
#         for i in range(len(seq) - k + 1):
#             if seq[i] == k and any(seq[i + j + 1] == k for j in range(k - 1)):
#                 break
#         else:
#             if seq not in known:
#                 b += [(" ".join(map(str, seq)))]
#                 known += [seq]
        
#         for s in b:
#             # print(s)
#             case = s.count(str(k))
#             mapping.setdefault(case, 0)
#             mapping[case] += 1
    
#     return sum(mapping.values()) % (10 ** 9 + 7)


# for k in range(2, 9):
#     for n in range(1, 50):
#         known = {}
#         if dumb(k, n) != smart(n, k):
#             print(n, k, dumb(k, n), smart(n, k))

print(smart(n, A[1]))

